routes/admin.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Administrator Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@index')->name('dashboard');

// Route::get('/author', 'AuthorController@index')->name('author');
// Route::get('/author/create', 'AuthorController@create')->name('author.create');
// Route::post('/author', 'AuthorController@store')->name('author.store');
// Route::get('/author/{author}/edit', 'AuthorController@edit')->name('author.edit');
// Route::put('/author/{author}', 'AuthorController@update')->name('author.update');
// Route::delete('/author/{author}', 'AuthorController@destroy')->name('author.destroy');

//Datatables
Route::get('/author/data', 'DataCenterController@authorDatatable')->name('author.data');
Route::get('/book/data', 'DataCenterController@bookDatatable')->name('book.data');
Route::get('/borrow/data', 'DataCenterController@borrowDatatable')->name('borrow.data');
//-----------------------------------------------------------------------------------------


Route::resource('/author', 'AuthorController');
Route::resource('/book', 'BookController');

Route::get('/borrow', 'BorrowController@index')->name('borrow.index');
Route::put('/borrow/{borrow}', 'BorrowController@update')->name('borrow.update');

Route::get('/report/top-book', 'ReportController@topBook')->name('report.top-book');
Route::get('/report/top-user', 'ReportController@topUser')->name('report.top-user');

routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'Frontend\\FrontendController@homePage')->name('homepage');
Route::get('/book/{book}', 'Frontend\\FrontendController@showBook')->name('book.show');
Route::post('/book/{book}/borrow', 'Frontend\\FrontendController@borrow')->name('book.borrow')->middleware(['auth']);

Auth::routes(['verify' => true]);

Route::get('/home', 'HomeController@index')->name('home')->middleware('verified');

app/Author.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Author extends Model
{
	protected $guarded = [];	

    public $timestamps = false;

    public function books()
    {
        return $this->hasMany(Book::class);
    }
}

app/Http/Controllers/Admin/AuthorController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Author;

class AuthorController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
       return view('admin.author.index', [
        'title' => 'Data Penulis'
       ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
       return view('admin.author.create', [
        'title' => 'Tambah Penulis'
       ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'name' => 'required|min:3',
        ]);

        Author::create($request->only('name'));

        return redirect()->route('admin.author.index')
            ->with('success', 'Data berhasil ditambah!');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Author $author)
    {
        return view('admin.author.edit', [
            'title' => 'Edit Penulis',
            'author' => $author
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Author $author)
    {
        $this->validate($request, [
            'name' => 'required|min:3',
        ]);
        
        $author->update($request->only('name'));

        return redirect()->route('admin.author.index')
        ->with('info', 'Data berhasil diupdate!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Author $author)
    {        
       $author->delete();

       return redirect()->route('admin.author.index')
       ->with('danger', 'Data berhasil dihapus!');
    }
}

resources/views/admin/author/action.blade.php
<a href="{{ route('admin.author.edit', $model) }}" class="btn btn-xs btn-warning">Edit</a>
<button href="{{ route('admin.author.destroy', $model) }}" class="btn btn-xs btn-danger" id="delete">Hapus</button>

<link href="//cdn.jsdelivr.net/npm/@sweetalert2/theme-dark@3/dark.css" rel="stylesheet">
<script src="//cdn.jsdelivr.net/npm/sweetalert2@9/dist/sweetalert2.min.js"></script>

<script src="https://cdn.jsdelivr.net/npm/sweetalert2@8"></script>
<script>
    $('button#delete').on('click', function(e){
        e.preventDefault();
        var href = $(this).attr('href');

        const swalWithBootstrapButtons = Swal.mixin({
		  customClass: {
		    confirmButton: 'btn btn-sm btn-success',
		    cancelButton: 'btn btn-sm btn-danger'
		  },
		  buttonsStyling: false
		});

		Swal.fire({
		  title: 'Apakah kamu yakin?',		   	  
		  text: "Anda tidak akan dapat mengembalikannya!",
		  icon: 'warning',		  
		  showCancelButton: true,
		  confirmButtonText: 'Ya, Hapus ini!',
		  cancelButtonText: 'Tidak, Batalkan!', 
		}).then((result) => {
		  if (result.value) {
		  	document.getElementById('deleteForm').action = href;
            document.getElementById('deleteForm').submit();

		    swalWithBootstrapButtons.fire(
		      'Terhapus!',
		      'Data berhasil dihapus dari sistem.',
		      'success'
		    )
		  } else if (
		    result.dismiss === Swal.DismissReason.cancel
		  ) {
		    swalWithBootstrapButtons.fire(
		      'Dibatalkan',
		      'Data berhasil diamakan :)',
		      'error'
		    )
		  }
		});        
    });
</script>

resources/views/admin/author/create.blade.php
@extends('admin.template.default')

@section('content')
<div class="card">
    <div class="card-header">
         <h3 class="card-title">Tambah Data Penulis</h3>         
    </div>
    <div class="card-body">
		<form action="{{ route('admin.author.store') }}" method="POST">
		@csrf
		  <div class="form-group row">
		    <label for="name" class="col-sm-2 col-form-label">Nama Penulis</label>
		    <div class="col-sm-10">
		      <input type="text" class="form-control @error('name') is-invalid @enderror" id="name" name="name" placeholder="Masukan Nama Penulis..." value="{{ old('name') }}">
			    @error('name') 
			       <span class="help-block">{{ $message }}</span>	
			    @enderror
		    </div>
		  </div>
		  <div class="form-group row">
		    <div class="col-sm-12">
		    	<input type="submit" value="Simpan" class="btn btn-success btn-sm float-right">		    	
		    </div>
		  </div>
		  
		</form>
    </div>
</div
@endsection

resources/views/admin/author/edit.blade.php
@extends('admin.template.default')

@section('content')
<div class="card">
    <div class="card-header">
         <h3 class="card-title">Edit Data Penulis</h3>         
    </div>
    <div class="card-body">
		<form action="{{ route('admin.author.update', [$author->id]) }}" method="POST">
		@csrf
		@method('PUT')
		  <div class="form-group row">
		    <label for="name" class="col-sm-2 col-form-label">Nama Penulis</label>
		    <div class="col-sm-10">
		      <input type="text" class="form-control @error('name') is-invalid @enderror" id="name" name="name" placeholder="Masukan Nama Penulis..." value="{{ old('name') ?? $author->name}}">
		      @error('name') 
			       <span class="help-block">{{ $message }}</span>	
			    @enderror
		    </div>
		  </div>
		  <div class="form-group row">
		    <div class="col-sm-12">
		    	<input type="submit" value="Ubah" class="btn btn-success btn-sm float-right">		    	
		    </div>
		  </div>		  
		</form>
    </div>
</div
@endsection

resources/views/admin/author/index.blade.php
@extends('admin.template.default')

@section('content')

<div class="card">
    <div class="card-header">
         <h3 class="card-title">Data Penulis</h3>
         <a href="{{ route('admin.author.create') }}" class="btn btn-primary btn-sm float-right">Tambah Penulis</a>
    </div>
    <div class="card-body">

		

		<table id="authorData" class="table table-bordered table-hover text-sm table-sm">
		 	<thead>
		 		<tr>
		 			<th>No</th>
		 			<th>Nama Penulis</th>
		 			<th>Aksi</th>
		 		</tr>
		 	</thead>
		 	<tbody>
		 		<tr></tr>
		 	</tbody>
		 </table>
    </div>
</div>
<form action="" method="post" id="deleteForm">
    @csrf
    @method("DELETE")
    <input type="submit" value="Hapus" style="display: none">
</form>
@endsection

@push('styles')
	 <link rel="stylesheet" href="{{ asset('assets/plugins/datatables-bs4/css/dataTables.bootstrap4.min.css') }}">
	 <link rel="stylesheet" href="{{ asset('assets/plugins/datatables-responsive/css/responsive.bootstrap4.min.css') }}"> 
@endpush


@push('jquery')
	<script src="{{ asset('assets/plugins/datatables/jquery.dataTables.min.js') }}"></script>
	<script src="{{ asset('assets/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js') }}"></script>
	<script src="{{ asset('assets/plugins/datatables-responsive/js/dataTables.responsive.min.js') }}"></script>
	<script src="{{ asset('assets/plugins/datatables-responsive/js/responsive.bootstrap4.min.js') }}"></script>
	<script src="{{ asset('assets/plugins/bootstrap-notify/bootstrap-notify.min.js') }}"></script>	
@endpush

@push('scripts')
	@include('admin.template.partials.alerts')
<script>
	$(function () {
		$('#authorData').DataTable({
		 		processing: true,
                serverSide: true,
                ajax: '{{ route('admin.author.data') }}',
                columns: [
                	{ data: 'DT_RowIndex', orderable: false, searchable : false},                
                    { data: 'name'} ,
                    { data: 'action'}                  
                ]                         
		});
	});
</script>
@endpush